<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSNMPMIB2ListReq StructType
 * @subpackage Structs
 */
class GetSNMPMIB2ListReq extends APIRequest
{
    /**
     * The sysContact
     * Meta informations extracted from the WSDL
     * - maxLength: 32
     * @var string
     */
    public $sysContact;
    /**
     * Constructor method for GetSNMPMIB2ListReq
     * @uses GetSNMPMIB2ListReq::setSysContact()
     * @param string $sysContact
     */
    public function __construct($sysContact = null)
    {
        $this
            ->setSysContact($sysContact);
    }
    /**
     * Get sysContact value
     * @return string|null
     */
    public function getSysContact()
    {
        return $this->sysContact;
    }
    /**
     * Set sysContact value
     * @param string $sysContact
     * @return GetSNMPMIB2ListReq
     */
    public function setSysContact($sysContact = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($sysContact) && strlen($sysContact) > 32) || (is_array($sysContact) && count($sysContact) > 32)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 32 element(s) or a scalar of 32 character(s) at most, "%d" length given', is_scalar($sysContact) ? strlen($sysContact) : count($sysContact)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($sysContact) && !is_string($sysContact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sysContact)), __LINE__);
        }
        $this->sysContact = $sysContact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return GetSNMPMIB2ListReq
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
